diff --git a/test/unit/daemon/recoverable_marker_retry_test.rb b/test/unit/daemon/recoverable_marker_retry_test.rb
new file mode 100644
index 00000000..285b7c3b
--- /dev/null
+++ b/test/unit/daemon/recoverable_marker_retry_test.rb
@@ -0,0 +1,137 @@
+require "test_helper"
+require "hive/daemon/recoverable_marker_retry"
+require "hive/daemon/auto_retry_health"
+
+class HiveDaemonRecoverableMarkerRetryTest < Minitest::Test
+  include HiveTestHelper
+
+  Row = Struct.new(:project, :slug, :task_id, :stage, :marker, :marker_attrs, :folder,
+                   :state_file, :worktree_path, :live_task_lock, keyword_init: true)
+
+  class CaptureLogger
+    attr_reader :events
+
+    def initialize
+      @events = []
+    end
+
+    def event(name, **attrs)
+      @events << [ name, attrs ]
+    end
+  end
+
+  def test_first_recovery_is_immediately_eligible_and_records_a_durable_baseline
+    with_row do |row, candidate|
+      retry_policy = policy(fingerprint: "healthy-a")
+      decision = retry_policy.decide(row, now: Time.utc(2026, 7, 24, 12, 0, 0))
+
+      assert decision.approved?
+      assert_equal 1, decision.attempt
+      assert retry_policy.record_recovery(row, decision, now: Time.utc(2026, 7, 24, 12, 0, 1))
+      events = event_records(row)
+      assert_equal %w[auto_retry_failure_observed auto_retry_decision], events.map { |event| event["event_type"] }
+      assert_equal "healthy-a", events.first.dig("details", "baseline_fingerprint")
+    end
+  end
+
+  def test_second_attempt_requires_delay_and_changed_fingerprint_then_exhausts
+    with_row do |row, _candidate|
+      start = Time.now.utc
+      first = policy(fingerprint: "healthy-a")
+      initial = first.decide(row, now: start)
+      first.record_recovery(row, initial, now: start)
+
+      early = policy(fingerprint: "healthy-b").decide(row, now: start + 60)
+      assert_equal "second_attempt_backoff", early.code
+
+      unchanged = policy(fingerprint: "healthy-a").decide(row, now: start + 1801)
+      assert_equal "second_attempt_signal_unchanged", unchanged.code
+
+      second_policy = policy(fingerprint: "healthy-b")
+      second = second_policy.decide(row, now: start + 1801)
+      assert second.approved?
+      assert_equal 2, second.attempt
+      second_policy.record_recovery(row, second, now: start + 1801)
+
+      exhausted = policy(fingerprint: "healthy-c").decide(row, now: start + 3602)
+      assert_equal "retry_budget_exhausted", exhausted.code
+    end
+  end
+
+  def test_substantive_plan_and_live_lock_refuse_before_probe
+    with_row do |row, _candidate|
+      File.write(File.join(row.folder, "plan.md"), "# user-authored plan\n")
+      health = FakeHealth.new("healthy")
+      result = policy(health: health).decide(row)
+      assert_equal "plan_substantive", result.code
+      assert_equal 0, health.calls
+
+      File.delete(File.join(row.folder, "plan.md"))
+      row.live_task_lock = true
+      result = policy(health: health).decide(row)
+      assert_equal "live_stage_owner", result.code
+      assert_equal 0, health.calls
+    end
+  end
+
+  def test_malformed_ledger_fails_closed
+    with_row do |row, _candidate|
+      File.write(File.join(row.folder, "events.jsonl"), "{bad json\n")
+      result = policy(fingerprint: "healthy").decide(row)
+      assert_equal "ledger_malformed", result.code
+    end
+  end
+
+  private
+
+  class FakeHealth
+    attr_reader :calls
+
+    def initialize(fingerprint)
+      @fingerprint = fingerprint
+      @calls = 0
+    end
+
+    def bundle_for(_row, _candidate)
+      @calls += 1
+      probe = Hive::Daemon::AutoRetryHealth::Probe.new(name: "all", healthy: true, exit_status: 0,
+                                                        timed_out: false, duration_ms: 1, stdout: "", stderr: "", fingerprint: "p")
+      Hive::Daemon::AutoRetryHealth::Bundle.new(healthy: true, reason: "claude_launch_failed", probes: [ probe ],
+                                                 cheap_fingerprint: "cheap", fingerprint: @fingerprint)
+    end
+  end
+
+  def with_row
+    with_tmp_dir do |dir|
+      state = File.join(dir, "task.md")
+      Hive::Markers.set(state, :error, reason: "claude_launch_failed", exception_class: "Hive::AgentError",
+                         message: "claude interactive prompt did not become ready in tmux session hive-plan-task")
+      marker = Hive::Markers.current(state)
+      row = Row.new(project: "p", slug: "task", task_id: 58, stage: "3-plan", marker: "error",
+                    marker_attrs: marker.attrs, folder: dir, state_file: state, worktree_path: nil, live_task_lock: false)
+      candidate = Hive::Daemon::RecoverableFailure::Candidate.new(
+        marker_id: marker.attrs.fetch("marker_id"), reason: "claude_launch_failed", stage: "3-plan",
+        diagnostic_kind: "claude_launch", evidence_source: "marker", task_id: 58, task_folder: dir, worktree_path: nil,
+        evidence: marker.attrs.fetch("message")
+      )
+      yield row, candidate
+    end
+  end
+
+  def policy(fingerprint: nil, health: nil)
+    classifier = Object.new
+    classifier.define_singleton_method(:classify) do |row|
+      Hive::Daemon::RecoverableFailure::Candidate.new(
+        marker_id: row.marker_attrs.fetch("marker_id"), reason: row.marker_attrs.fetch("reason"), stage: row.stage,
+        diagnostic_kind: "claude_launch", evidence_source: "marker", task_id: row.task_id, task_folder: row.folder,
+        worktree_path: row.worktree_path, evidence: row.marker_attrs.fetch("message")
+      )
+    end
+    Hive::Daemon::RecoverableMarkerRetry.new(classifier: classifier, health: health || FakeHealth.new(fingerprint),
+                                             logger: CaptureLogger.new, commit_events: false)
+  end
+
+  def event_records(row)
+    File.readlines(File.join(row.folder, "events.jsonl"), chomp: true).map { |line| JSON.parse(line) }
+  end
+end
diff --git a/test/unit/daemon/stale_agent_healer_test.rb b/test/unit/daemon/stale_agent_healer_test.rb
index 158a6cf0..bdaabd73 100644
--- a/test/unit/daemon/stale_agent_healer_test.rb
+++ b/test/unit/daemon/stale_agent_healer_test.rb
@@ -125,6 +125,24 @@ class HiveDaemonStaleAgentHealerTest < Minitest::Test
     end
   end
 
+  def test_kill_switch_keeps_terminal_error_parked_but_preserves_dead_agent_reconciliation
+    with_marker_file do |state_file|
+      Hive::Markers.set(state_file, :error, reason: "unpushed_commits")
+      terminal = make_row(state_file, pid_alive: nil, stage: "8-finalize", marker: "error",
+                          marker_attrs: Hive::Markers.current(state_file).attrs)
+      disabled = Hive::Daemon::StaleAgentHealer.new(
+        controller: @controller, logger: @logger, grace_sec: 300,
+        request_queue: @request_queue, auto_retry_enabled: false
+      )
+      disabled.heal([ terminal ], now: NOW)
+      assert_equal :error, Hive::Markers.current(state_file).name
+
+      File.write(state_file, "<!-- AGENT_WORKING -->\n")
+      disabled.heal([ make_row(state_file, pid_alive: false) ], now: NOW)
+      assert_equal "agent_died", Hive::Markers.current(state_file).attrs["reason"]
+    end
+  end
+
   def test_leaves_pidless_placeholder_within_grace
     with_marker_file do |state_file|
       row = make_row(state_file, pid_alive: nil, mtime: NOW - 60)
diff --git a/test/unit/daemon/status_consumer_test.rb b/test/unit/daemon/status_consumer_test.rb
index a342b30a..907b4025 100644
--- a/test/unit/daemon/status_consumer_test.rb
+++ b/test/unit/daemon/status_consumer_test.rb
@@ -80,6 +80,17 @@ class HiveDaemonStatusConsumerTest < Minitest::Test
     end
   end
 
+  def test_keeps_task_identity_and_worktree_path_when_newer_status_payload_supplies_them
+    task = task_row(slug: "recoverable").merge("id" => 58, "worktree_path" => "/tmp/worktrees/recoverable")
+    payload = make_envelope(projects: [ { "name" => "p", "tasks" => [ task ] } ])
+
+    with_fake_status(JSON.generate(payload)) do |bin|
+      row = Hive::Daemon::StatusConsumer.new(hive_bin: bin).fetch.rows.first
+      assert_equal 58, row.task_id
+      assert_equal "/tmp/worktrees/recoverable", row.worktree_path
+    end
+  end
+
   # Issue #144: the daemon healer and dispatcher use `row.live_task_lock`
   # to recognise a live `hive run` during the pre-claude_pid window. Pin
   # the parse of the JSON key here so a regression in `task_payload`
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 28ac2224..64661d87 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -19,13 +19,27 @@ class EventsTest < Minitest::Test
       lines = File.readlines(File.join(dir, "events.jsonl"), chomp: true)
       assert_equal 1, lines.size
       parsed = JSON.parse(lines.first)
-      assert_equal %w[ts slug stage agent event_type message], parsed.keys
+      assert_equal %w[ts slug stage agent event_type message details], parsed.keys
       assert_equal "4-execute", parsed.fetch("stage")
       assert_equal "agent_start", parsed.fetch("event_type")
       assert_match(/\A\d{4}-\d{2}-\d{2}T/, parsed.fetch("ts"))
     end
   end
 
+  def test_emit_redacts_and_caps_structured_details
+    with_tmp_dir do |dir|
+      Hive::Events.emit(
+        task_folder: dir, slug: "event-test-260522-aaaa", stage: "4-execute",
+        event_type: :auto_retry_decision,
+        details: { "probe" => "Authorization: Bearer sk-123456789012345678901234567890", "large" => "x" * 10_000 }
+      )
+
+      details = JSON.parse(File.read(File.join(dir, "events.jsonl"))).fetch("details")
+      refute_includes JSON.generate(details), "sk-123456789012345678901234567890"
+      assert details["truncated"] || details["probe"].include?("[REDACTED")
+    end
+  end
+
   def test_sequential_emits_append_distinct_lines
     with_tmp_dir do |dir|
       Hive::Events.emit(task_folder: dir, slug: "event-test-260522-aaaa", stage: "2-brainstorm",
diff --git a/test/unit/stages/execute_test.rb b/test/unit/stages/execute_test.rb
index af52b588..831b915f 100644
--- a/test/unit/stages/execute_test.rb
+++ b/test/unit/stages/execute_test.rb
@@ -193,6 +193,26 @@ class HiveStagesExecuteTest < Minitest::Test
     end
   end
 
+  def test_run_pass_stamps_non_secret_codex_auth_diagnostic
+    with_tmp_dir do |dir|
+      task = build_task(dir)
+      write_plan(task)
+      write_pointer(task, "path" => File.join(dir, "worktree"), "branch" => task.slug, "execute_base_head" => "base")
+      git = FakeGit.new(head: "base", branch: task.slug, dirty: false, ancestor_result: true)
+      raw = "HTTP 401: missing bearer token Authorization: Bearer sk-super-secret-token-value"
+
+      with_fake_git_and_spawn(git, result: { status: :error, error_message: raw }) do
+        Hive::Stages::Execute.run_pass(task, execute_cfg("codex"), File.join(dir, "worktree"))
+      end
+
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal "codex", marker.attrs["provider"]
+      assert_equal "codex_auth_401", marker.attrs["diagnostic"]
+      assert_equal Hive::Daemon::RecoverableFailure::CODEX_AUTH_MESSAGE, marker.attrs["message"]
+      refute_includes marker.attrs["message"], "sk-super-secret-token-value"
+    end
+  end
+
   # When the execute agent name can't be resolved (unregistered profile),
   # `execute_agent_name` rescues to nil rather than letting the exception
   # escape; the limits_reached marker is still written, just with provider
